class Grid {
  constructor(str_filename, str_parent_id, str_id) {
    this.filename = str_filename;
    this.parent_id = str_parent_id;
    this.id = str_id;
    this.maxrow = 0;
    this.columns = [];
  }

  add_column(str_id, str_title, int_width) {
    this.columns.push([str_id, str_title, int_width]);
  }

  disable_onclick(id) {
   disableevents.push(id);
  }

  render(callback) {
    var el_grid = document.getElementById(this.parent_id);
    // Header
    var new_div_header = document.createElement('div');
    new_div_header.id = this.id + '_header'; 
    new_div_header.setAttribute('class', this.id + '_header');
    new_div_header.setAttribute('style', '');
    this.columns.forEach(element => {  
      var new_el1 = document.createElement('div');
      new_el1.id =  this.id + '_header' + '_' + element[0];
      new_el1.onclick = function() { var event = {type:'header', id:this.id, value:this.innerHTML, width:this.style.width, object:this}; callback(event); } 
      new_el1.setAttribute('style', 'float:left;');
      new_el1.innerHTML = element[1];
      new_el1.style.width = element[2];
      new_div_header.appendChild(new_el1);
    });

    var xhttp = new XMLHttpRequest();
    var thisobj = this;
    var new_columns = null;
    // Columns
    if(!this.maxrow && this.maxrow == 0)
      new_columns = document.createElement('div');
    else
      new_columns = document.getElementById(thisobj.id + '_columns'); 

    new_columns.setAttribute('style', '');
    new_columns.setAttribute('class', this.id + '_columns');
    new_columns.id = thisobj.id + '_columns'; 

    xhttp.onreadystatechange = function() {
      if(this.readyState == 4 && this.status == 200) {
        if(!this.responseText) {
          console.log('error with response');
          return;
        }

        var json = JSON.parse(this.responseText);
        var j = thisobj.maxrow;

        for(var i=0; i<json.length; i++) {
          var new_row = document.createElement('div');
          new_row.setAttribute('class', thisobj.id + '_row');
          new_row.id = thisobj.id + '_row_' + j; 
          new_row.onclick = function() { var event = { type:'row', id:this.id, value:this.innerHTML, width:this.style.width, object:this}; callback(event); };
          thisobj.columns.forEach(element => {
            var item = eval('json[' + i + '].' + element[0] + ';');
            var new_column = document.createElement('div');
            new_column.id = 'column_' + element[0] + '_row_' + j;
            new_column.onclick = function() { var event = { type:'column', id:this.id, value:this.innerHTML, width:this.style.width, object:this, grid:thisobj}; callback(event); };
            new_column.innerHTML = item;
            new_column.setAttribute('style', 'float:left;');
            new_column.style.width = element[2];
            new_row.appendChild(new_column);
            j++;
          });
          new_columns.appendChild(new_row);
        }
        thisobj.maxrow = j;
        el_grid.appendChild(new_div_header);
        el_grid.appendChild(new_columns);
      }
    }
    xhttp.open("GET", this.filename, true);
    xhttp.send();
  }

  rendermore(str_filename, callback) {
    this.filename = str_filename;
    this.render(callback);
  } 
}